| The Gaudi Framework v28r2p1 (f1a77ff4)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Private Attributes | List of all members
RndmGenSvc Class Reference

Random Generator service definition. More...

`#include <src/RndmGenSvc/RndmGenSvc.h>`

Inheritance diagram for RndmGenSvc:
[legend]
Collaboration diagram for RndmGenSvc:
[legend]

## Public Member Functions
| ~RndmGenSvc () override=default
StatusCode | initialize () override
| Service override: initialization. More...
StatusCode | finalize () override
| Service override: finalization. More...
StreamBuffer & | serialize (StreamBuffer &str) override
| IRndmGenSvc interface implementation. More...
StreamBuffer & | serialize (StreamBuffer &str) const override
| Output serialization to stream buffer. Saves the status of the generator engine. More...
IRndmEngine * | engine () override
| Retrieve engine. More...
StatusCode | generator (const IRndmGen::Param &par, IRndmGen *&refpGen) override
| Retrieve a valid generator from the service. More...
double | rndm () const override
| Single shot returning single random number. More...
StatusCode | rndmArray (std::vector< double > &array, long howmany, long start=0) const override
| Multiple shots returning vector with flat random numbers. More...
StatusCode | setSeeds (const std::vector< long > &seeds) override
| Allow to set new seeds. More...
StatusCode | seeds (std::vector< long > &seeds) const override
| Allow to get seeds. More...
Public Member Functions inherited from extends< Service, IRndmGenSvc, IRndmEngine, ISerialize >
void * | i_cast (const InterfaceID &tid) const override
| Implementation of IInterface::i_cast. More...
StatusCode | queryInterface (const InterfaceID &ti, void **pp) override
| Implementation of IInterface::queryInterface. More...
std::vector< std::string > | getInterfaceNames () const override
| Implementation of IInterface::getInterfaceNames. More...
| ~extends () override=default
| Virtual destructor. More...
Public Member Functions inherited from Service
const std::string & | name () const override
| Retrieve name of the service. More...
StatusCode | configure () override
StatusCode | initialize () override
StatusCode | start () override
StatusCode | stop () override
StatusCode | finalize () override
StatusCode | terminate () override
Gaudi::StateMachine::State | FSMState () const override
Gaudi::StateMachine::State | targetFSMState () const override
StatusCode | reinitialize () override
StatusCode | restart () override
StatusCode | sysInitialize () override
| Initialize Service. More...
StatusCode | sysStart () override
| Initialize Service. More...
StatusCode | sysStop () override
| Initialize Service. More...
StatusCode | sysFinalize () override
| Finalize Service. More...
StatusCode | sysReinitialize () override
| Re-initialize the Service. More...
StatusCode | sysRestart () override
| Re-initialize the Service. More...
| Service (std::string name, ISvcLocator *svcloc)
| Standard Constructor. More...
SmartIF< ISvcLocator > & | serviceLocator () const override
| Retrieve pointer to service locator. More...
StatusCode | setProperties ()
| Method for setting declared properties to the values specified for the job. More...
template<class T >
StatusCode | service (const std::string &name, const T *&psvc, bool createIf=true) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T >
StatusCode | service (const std::string &name, T *&psvc, bool createIf=true) const
template<typename IFace = IService>
SmartIF< IFace > | service (const std::string &name, bool createIf=true) const
template<class T >
StatusCode | service (const std::string &svcType, const std::string &svcName, T *&psvc) const
| Access a service by name and type, creating it if it doesn't already exist. More...
template<class T >
StatusCode | declarePrivateTool (ToolHandle< T > &handle, std::string toolTypeAndName="", bool createIf=true)
| Declare used Private tool. More...
template<class T >
StatusCode | declarePublicTool (ToolHandle< T > &handle, std::string toolTypeAndName="", bool createIf=true)
| Declare used Public tool. More...
SmartIF< IAuditorSvc > & | auditorSvc () const
| The standard auditor service.May not be invoked before sysInitialize() has been invoked. More...
Public Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| PropertyHolder ()=default
| ~PropertyHolder () override=default
Gaudi::Details::PropertyBase & | declareProperty (Gaudi::Details::PropertyBase &prop)
| Declare a property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none")
| Helper to wrap a regular data member and use it as a regular property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none") const
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, Gaudi::Property< TYPE, VERIFIER, HANDLERS > &prop, const std::string &doc="none")
| Declare a PropertyBase instance setting name and documentation. More...
Gaudi::Details::PropertyBase * | declareRemoteProperty (const std::string &name, IProperty *rsvc, const std::string &rname="")
| Declare a remote property. More...
StatusCode | setProperty (const Gaudi::Details::PropertyBase &p) override
| set the property form another property More...
StatusCode | setProperty (const std::string &s) override
| set the property from the formatted string More...
StatusCode | setProperty (const std::string &n, const std::string &v) override
| set the property from name and the value More...
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
StatusCode | getProperty (Gaudi::Details::PropertyBase *p) const override
| get the property More...
const Gaudi::Details::PropertyBase & | getProperty (const std::string &name) const override
| get the property by name More...
StatusCode | getProperty (const std::string &n, std::string &v) const override
| convert the property to the string More...
const std::vector< Gaudi::Details::PropertyBase * > & | getProperties () const override
| get all properties More...
bool | hasProperty (const std::string &name) const override
| Return true if we have a property with the given name. More...
| PropertyHolder (const PropertyHolder &)=delete
PropertyHolder & | operator= (const PropertyHolder &)=delete
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, GaudiHandleBase &ref, const std::string &doc="none")
| Specializations for various GaudiHandles. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, GaudiHandleArrayBase &ref, const std::string &doc="none")
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, DataObjectHandleBase &ref, const std::string &doc="none")
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...
MSG::Level | msgLevel () const
| get the output level from the embedded MsgStream More...
MSG::Level | outputLevel () const __attribute__((deprecated))
| Backward compatibility function for getting the output level. More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...
Public Member Functions inherited from extend_interfaces< Interfaces... >
| ~extend_interfaces () override=default
| Virtual destructor. More...

## Private Attributes
SmartIF< IRndmEngine > | m_engine
| Random number engine. More...
SmartIF< ISerialize > | m_serialize
| Serialization interface of random number engine. More...
Gaudi::Property< std::string > | m_engineName {this, "Engine", "HepRndm::Engine<CLHEP::RanluxEngine>", "engine name"}

## Additional Inherited Members
Public Types inherited from extends< Service, IRndmGenSvc, IRndmEngine, ISerialize >
using | base_class = extends
| Typedef to this class. More...
using | extend_interfaces_base = extend_interfaces< Interfaces... >
| Typedef to the base of this class. More...
Public Types inherited from Service
typedef Gaudi::PluginService::Factory< IService *, const std::string &, ISvcLocator * > | Factory
Public Types inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
using | PropertyHolderImpl = PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| Typedef used to refer to this class from derived classes, as in. More...
Public Types inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
using | base_class = CommonMessaging
Public Types inherited from extend_interfaces< Interfaces... >
using | ext_iids = typename Gaudi::interface_list_cat< typename Interfaces::ext_iids... >::type
| take union of the ext_iids of all Interfaces... More...
Protected Member Functions inherited from Service
| ~Service () override
| Standard Destructor. More...
int | outputLevel () const
| get the `Service's` output level More...
Protected Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
Gaudi::Details::PropertyBase * | property (const std::string &name) const
Protected Member Functions inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...
Protected Attributes inherited from Service
Gaudi::StateMachine::State | m_state = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::StateMachine::State | m_targetState = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::Property< int > | m_outputLevel {this, "OutputLevel", MSG::NIL, "output level"}
Gaudi::Property< bool > | m_auditInit {this, "AuditServices", false, "[[deprecated]] unused"}
Gaudi::Property< bool > | m_auditorInitialize {this, "AuditInitialize", false, "trigger auditor on initialize()"}
Gaudi::Property< bool > | m_auditorStart {this, "AuditStart", false, "trigger auditor on start()"}
Gaudi::Property< bool > | m_auditorStop {this, "AuditStop", false, "trigger auditor on stop()"}
Gaudi::Property< bool > | m_auditorFinalize {this, "AuditFinalize", false, "trigger auditor on finalize()"}
Gaudi::Property< bool > | m_auditorReinitialize {this, "AuditReinitialize", false, "trigger auditor on reinitialize()"}
Gaudi::Property< bool > | m_auditorRestart {this, "AuditRestart", false, "trigger auditor on restart()"}
SmartIF< IAuditorSvc > | m_pAuditorSvc
| Auditor Service. More...

## Detailed Description

Random Generator service definition.

Description: Definition of a interface for a service to access random generators according to predefined distributions. For more detailed explanations please see the interface definition.

Dependencies:

- Base class: Gaudi/RndmGenSvc/ISerialize.h
- Base class: Gaudi/RndmGenSvc/IRandomGenSvc.h

History :

    +---------+----------------------------------------------+--------+
    |    Date |                 Comment                      | Who    |
    +---------+----------------------------------------------+--------+
    | 21/04/99| Initial version.                             | MF     |
    +---------+----------------------------------------------+--------+

Author: M.Frank Version: 1.0

Definition at line 49 of file RndmGenSvc.h.

## Constructor & Destructor Documentation

RndmGenSvc::~RndmGenSvc | ( |  | ) |
| override default

## Member Function Documentation

IRndmEngine * RndmGenSvc::engine | ( |  | ) |
| override

Retrieve engine.

Definition at line 95 of file RndmGenSvc.cpp.

95 {
96 return m_engine.get();
97 }
RndmGenSvc::m_engine
SmartIF< IRndmEngine > m_engine
Random number engine.
Definition: RndmGenSvc.h:53
SmartIF::get
TYPE * get() const
Get interface pointer.
Definition: SmartIF.h:76

StatusCode RndmGenSvc::finalize | ( |  | ) |
| override

Service override: finalization.

Definition at line 69 of file RndmGenSvc.cpp.

69 {
70 StatusCode status = Service::finalize();
71 m_serialize.reset();
72 if ( m_engine ) {
73 m_engine.as<IService>()->finalize().ignore();
74 m_engine.reset();
75 }
76 return status;
77 }
Service::finalize
StatusCode finalize() override
Definition: Service.cpp:174
RndmGenSvc::finalize
StatusCode finalize() override
Service override: finalization.
Definition: RndmGenSvc.cpp:69
RndmGenSvc::m_engine
SmartIF< IRndmEngine > m_engine
Random number engine.
Definition: RndmGenSvc.h:53
SmartIF::as
SmartIF< IFace > as() const
return a new SmartIF instance to another interface
Definition: SmartIF.h:110
IService
General service interface definition.
Definition: IService.h:18
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:26
SmartIF::reset
void reset(TYPE *ptr=nullptr)
Set the internal pointer to the passed one disposing of the old one.
Definition: SmartIF.h:88
RndmGenSvc::m_serialize
SmartIF< ISerialize > m_serialize
Serialization interface of random number engine.
Definition: RndmGenSvc.h:55
StatusCode::ignore
void ignore() const
Definition: StatusCode.h:106

StatusCode RndmGenSvc::generator | ( | const IRndmGen::Param & | par,
|  | IRndmGen *& | refpGen
| ) |  |
| override

Retrieve a valid generator from the service.

Definition at line 100 of file RndmGenSvc.cpp.

100 {
101 auto pGen = SmartIF<IRndmGen>( ObjFactory::create(par.type(),m_engine.get()) );
102 if (!pGen) {
103 refpGen = nullptr;
104 return StatusCode::FAILURE;
105 }
106 refpGen = pGen.get();
107 refpGen->addRef(); // insure the caller gets something with a refCount of (at least) one back...
108 return refpGen->initialize(par);
109 }
IRndmGen::initialize
virtual StatusCode initialize(const IRndmGen::Param &par)=0
Initialize the generator.
SmartIF< IRndmGen >
StatusCode::FAILURE
Definition: StatusCode.h:29
IRndmGen::Param::type
virtual const InterfaceID & type() const
Parameter&#39;s type.
Definition: IRndmGen.h:50
RndmGenSvc::m_engine
SmartIF< IRndmEngine > m_engine
Random number engine.
Definition: RndmGenSvc.h:53
SmartIF::get
TYPE * get() const
Get interface pointer.
Definition: SmartIF.h:76
IInterface::addRef
virtual unsigned long addRef()=0
Increment the reference count of Interface instance.

StatusCode RndmGenSvc::initialize | ( |  | ) |
| override

Service override: initialization.

Definition at line 35 of file RndmGenSvc.cpp.

35 {
36 StatusCode status = Service::initialize();
37
38 auto mgr = serviceLocator()->as<ISvcManager>();
39
40 if ( status.isSuccess() ) {
41 status = setProperties();
42 if ( status.isSuccess() ) { // Check if the Engine service exists:
43 // FIXME: (MCl) why RndmGenSvc cannot create the engine service in a standard way?
44 const bool CREATE = false;
45 std::string machName = name()+".Engine";
46 auto engine = serviceLocator()->service<IRndmEngine>(machName, CREATE);
47 if ( !engine && mgr ) {
48 using Gaudi::Utils::TypeNameString;
49 engine = mgr->createService(TypeNameString(machName, m_engineName));
50 }
51 if ( engine ) {
52 auto serial = engine.as<ISerialize>();
53 auto service = engine.as<IService>();
54 if ( serial && service ) {
55 status = service->sysInitialize();
56 if ( status.isSuccess() ) {
57 m_engine = engine;
58 m_serialize = serial;
59 info() << "Using Random engine:" << m_engineName.value() << endmsg;
60 }
61 }
62 }
63 }
64 }
65 return status;
66 }
Service::initialize
StatusCode initialize() override
Definition: Service.cpp:64
Service::name
const std::string & name() const override
Retrieve name of the service.
Definition: Service.cpp:289
CommonMessagingBase::info
MsgStream & info() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:123
ISvcManager
The ISvcManager is the interface implemented by the Service Factory in the Application Manager to sup...
Definition: ISvcManager.h:28
StatusCode::isSuccess
bool isSuccess() const
Test for a status code of SUCCESS.
Definition: StatusCode.h:74
RndmGenSvc::m_engine
SmartIF< IRndmEngine > m_engine
Random number engine.
Definition: RndmGenSvc.h:53
RndmGenSvc::m_engineName
Gaudi::Property< std::string > m_engineName
Definition: RndmGenSvc.h:57
ISvcLocator::as
SmartIF< IFace > as()
Definition: ISvcLocator.h:106
std::string
STL class.
ISvcLocator::service
StatusCode service(const Gaudi::Utils::TypeNameString &name, T *&svc, bool createIf=true)
Templated method to access a service by name.
Definition: ISvcLocator.h:78
Gaudi::Utils::TypeNameString
Helper class to parse a string of format "type/name".
Definition: TypeNameString.h:12
IService
General service interface definition.
Definition: IService.h:18
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:26
Service::setProperties
StatusCode setProperties()
Method for setting declared properties to the values specified for the job.
Definition: Service.cpp:295
Io::CREATE
Definition: IFileMgr.h:30
Service::service
StatusCode service(const std::string &name, const T *&psvc, bool createIf=true) const
Access a service by name, creating it if it doesn&#39;t already exist.
Definition: Service.h:85
IRndmEngine
Definition of a interface for a generic random number generator giving randomly distributed numbers i...
Definition: IRndmEngine.h:19
RndmGenSvc::engine
IRndmEngine * engine() override
Retrieve engine.
Definition: RndmGenSvc.cpp:95
RndmGenSvc::m_serialize
SmartIF< ISerialize > m_serialize
Serialization interface of random number engine.
Definition: RndmGenSvc.h:55
ISerialize
Object serialization interface definition.
Definition: ISerialize.h:17
Service::serviceLocator
SmartIF< ISvcLocator > & serviceLocator() const override
Retrieve pointer to service locator.
Definition: Service.cpp:292
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244

double RndmGenSvc::rndm | ( |  | ) | const
| override

Single shot returning single random number.

Definition at line 112 of file RndmGenSvc.cpp.

112 {
113 return m_engine ? m_engine->rndm() : -1;
114 }
IRndmEngine::rndm
virtual double rndm() const =0
Single shot returning single random number.
RndmGenSvc::m_engine
SmartIF< IRndmEngine > m_engine
Random number engine.
Definition: RndmGenSvc.h:53

StatusCode RndmGenSvc::rndmArray | ( | std::vector< double > & | array,
|  | long | howmany,
|  | long | start = `0`
| ) |  | const
| override

Multiple shots returning vector with flat random numbers.

Parameters

  array | Array containing random numbers
  howmany | fill 'howmany' random numbers into array
  start | ... starting at position start

Returns
  StatusCode indicating failure or success.

Definition at line 122 of file RndmGenSvc.cpp.

122 {
123 return m_engine ? m_engine->rndmArray(array, howmany, start)
124 : StatusCode::FAILURE;
125 }
StatusCode::FAILURE
Definition: StatusCode.h:29
Service::start
StatusCode start() override
Definition: Service.cpp:137
RndmGenSvc::m_engine
SmartIF< IRndmEngine > m_engine
Random number engine.
Definition: RndmGenSvc.h:53
IRndmEngine::rndmArray
virtual StatusCode rndmArray(std::vector< double > &array, long howmany, long start=0) const =0
Multiple shots returning vector with flat random numbers.

StatusCode RndmGenSvc::seeds | ( | std::vector< long > & | seeds | ) | const
| override

Allow to get seeds.

Definition at line 134 of file RndmGenSvc.cpp.

134 {
135 return m_engine ? m_engine->seeds(seeds)
136 : StatusCode::FAILURE;
137 }
IRndmEngine::seeds
virtual StatusCode seeds(std::vector< long > &seeds) const =0
Allow to retrieve seeds.
StatusCode::FAILURE
Definition: StatusCode.h:29
RndmGenSvc::m_engine
SmartIF< IRndmEngine > m_engine
Random number engine.
Definition: RndmGenSvc.h:53

StreamBuffer & RndmGenSvc::serialize | ( | StreamBuffer & | str | ) |
| override

IRndmGenSvc interface implementation.

Input serialization from stream buffer. Restores the status of the generator engine.

Definition at line 81 of file RndmGenSvc.cpp.

81 {
82 if ( m_serialize ) return m_serialize->serialize(str);
83 error() << "Cannot input serialize Generator settings!" << endmsg;
84 return str;
85 }
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:117
ISerialize::serialize
virtual StreamBuffer & serialize(StreamBuffer &str)=0
Input serialization from stream buffer.
RndmGenSvc::m_serialize
SmartIF< ISerialize > m_serialize
Serialization interface of random number engine.
Definition: RndmGenSvc.h:55
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244

StreamBuffer & RndmGenSvc::serialize | ( | StreamBuffer & | str | ) | const
| override

Output serialization to stream buffer. Saves the status of the generator engine.

Definition at line 88 of file RndmGenSvc.cpp.

88 {
89 if ( m_serialize ) return m_serialize->serialize(str);
90 error() << "Cannot output serialize Generator settings!" << endmsg;
91 return str;
92 }
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:117
ISerialize::serialize
virtual StreamBuffer & serialize(StreamBuffer &str)=0
Input serialization from stream buffer.
RndmGenSvc::m_serialize
SmartIF< ISerialize > m_serialize
Serialization interface of random number engine.
Definition: RndmGenSvc.h:55
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244

StatusCode RndmGenSvc::setSeeds | ( | const std::vector< long > & | seeds | ) |
| override

Allow to set new seeds.

Definition at line 128 of file RndmGenSvc.cpp.

128 {
129 return m_engine ? m_engine->setSeeds(seeds)
130 : StatusCode::FAILURE;
131 }
StatusCode::FAILURE
Definition: StatusCode.h:29
RndmGenSvc::m_engine
SmartIF< IRndmEngine > m_engine
Random number engine.
Definition: RndmGenSvc.h:53
IRndmEngine::setSeeds
virtual StatusCode setSeeds(const std::vector< long > &seeds)=0
Allow to set new seeds.

## Member Data Documentation

SmartIF<IRndmEngine> RndmGenSvc::m_engine
| mutable private

Random number engine.

Definition at line 53 of file RndmGenSvc.h.

Gaudi::Property<std::string> RndmGenSvc::m_engineName {this, "Engine", "HepRndm::Engine<CLHEP::RanluxEngine>", "engine name"}
| private

Definition at line 57 of file RndmGenSvc.h.

SmartIF<ISerialize> RndmGenSvc::m_serialize
| mutable private

Serialization interface of random number engine.

Definition at line 55 of file RndmGenSvc.h.

The documentation for this class was generated from the following files:

- GaudiSvc/src/RndmGenSvc/RndmGenSvc.h
- GaudiSvc/src/RndmGenSvc/RndmGenSvc.cpp